# Adventure Pack

## Install
### Build

``shell
TBD
```

## Timeline
### Milestone 01: Planning
- [x] Establish timeline
- [x] Naming
  - [x] Application name and binary
    - Decision (name): Adventure Pack
    - Decision (binary): adventure-pack
  - [x] Character sheet file name
    - Decision: *.apc
  - [x] Campaign (Story) sheet file name
    - Decision: *.aps
- [x] Saving method
  - Decision: JSON
  - Reasoning: INI file is too simplistic and does not allow for easy arrays, this
               is an issue regarding the inventory. While a database like SQLite 
               might be a recommended choice, shipping an entire DB seems like
               overkill for this project. A JSON file also makes the character 
               sheet portable, so web applications (i.e written in PHP) or a 
               mobile version of the program (i.e written in Java, swift, etc..)
               could parse the file as well.
               GTK also provides a json-glib library, which makes writting/reading
               JSON easy.
- [ ] Creating saving method example
- [ ] Application Layout
  - [ ] Character sheet
    - [ ] Bio
      - [x] Name
      - [x] Race
      - [x] Background
      - [ ] Alignment
      - [x] XP
      - [ ] Age
      - [ ] Weight
      - [ ] Height
      - [ ] Eyes
      - [ ] Hair
      - [ ] Skin
      - [ ] Other
    - [x] History
      - [x] Personal Traits
      - [x] Ideals
      - [x] Bonds
      - [x] Flaws
      - [x] Features & Traits
    - [x] Abiltiies
    - [x] Skills
    - [x] Saving Throws
    - [x] Inspiration
    - [x] Proficency Bonus
    - [x] Passive Wisdom (Perception)
    - [x] Attacks & Spellcasting
    - [x] Other Proficencies
    - [x] Languages
    - [x] Health
    - [x] Weapons
    - [x] Armor
    - [x] Inventory
      - [x] Search
      - [x] Money
        - [x] Copper Pieces (CP)
        - [x] Silver Pieces (SP)
        - [x] Electrum Pieces (EP)
        - [x] Gold pieces (GP)
        - [x] Platinum Pieces (PP)
      - [x] Weight
      - [x] Other items list
  - [x] Dice roller (new window/pop-over?)
  - [x] Save
  - [ ] Undo
  - [ ] Import/Export sheets info
  - [x] Application Menu
    - [x] Basics (Preferences, Keyboard Shortcuts, Help, About, Quit)
    - [ ] Mode switching (Player/DM)

### Milestone 02: Basics
Lots of plumbing in this milestone, so it's smaller
- [ ] Create layout in ui/glade file
- [ ] Create backend to create ans save sheets
- [ ] Connect back-end and layout
- [ ] Update other stats based of new info
- [ ] Import/Export
- [ ] Temp changes / recover if crash

### Milestone 03: Upgrades & DnD Versions
- [ ] Guided mode for creating a character (for beginners)
- [ ] Robust dice system
- [ ] Categorizing and sorting inventory
- [ ] Ability to pick a version of D&D or other game
  - [ ] Add the ability to select default data for sheets
- [ ] Randomizer

### Milestone 04: Advanced Feature Set (AFS Update)
- [ ] Character
  - [ ] Upload character
  - [ ] Draw character (GL Area)
- [ ] Map
  - [ ] Upload map
  - [ ] Draw map (GL Area)

### Milestone 05: Campaign (Magic Update)
Using the power of "magic" we enable online play. Extremly complex, need help.
WILL NOT ATTEMPT untill other areas are solid.
- [ ] Online play
  - [ ] Create session
  - [ ] Connecting
  - [ ] Sharing data
    - [ ] Sheets
    - [ ] Characters
    - [ ] Maps
    - [ ] Location
  - [ ] Realtime
  - [ ] Chat
